#include "gamecube.h"
#include <algorithm>
#include <ctime>

// -----------------------------------------------------------
// 3D Memory Game – Hauptprogramm
// -----------------------------------------------------------
int main()
{
    // Zufall initialisieren
    srand(time(NULL));

    // Fenster und Kamera
    InitWindow(800, 600, "3D Memory Game with Matrix3D Library");
    SetTargetFPS(60);

    Camera3D camera{};
    camera.position = {6.0f, 6.0f, 6.0f};
    camera.target   = {0.0f, 0.0f, 0.0f};
    camera.up       = {0.0f, 1.0f, 0.0f};
    camera.fovy     = 45.0f;
    camera.projection = CAMERA_PERSPECTIVE;

    // Nur 3 Farben für 3 Paare
    Color colors[] = { RED, GREEN, BLUE };

    // 6 Karten-Positionen im 3x2 Raster
    std::vector<Vec3> positions = {{-2, 0, -2}, {0, 0, -2}, {2, 0, -2},{-2, 0,  0}, {0, 0,  0}, {2, 0,  0}};

    // Farben doppelt in einen Pool legen und mischen
    std::vector<Color> colorPool;
    for (int i = 0; i < 3; i++)
    {
        colorPool.push_back(colors[i]);
        colorPool.push_back(colors[i]);
    }

    // Fisher-Yates Shuffle mit rand()
    for (int i = colorPool.size() - 1; i > 0; --i)
    {
        int j = rand() % (i + 1);   // Zufallsindex von 0 bis i
        std::swap(colorPool[i], colorPool[j]);
    }

    // Karten/Würfel erstellen
    std::vector<gamecube> cubes;
    for (int i = 0; i < 6; i++)
        cubes.emplace_back(positions[i], colorPool[i]);

    gamecube* first  = nullptr;
    gamecube* second = nullptr;
    float flipSpeed = 5.0f;  // Drehgeschwindigkeit
    bool gameWon = false;

    // -----------------------------------------------------------
    // Hauptspielschleife
    // -----------------------------------------------------------
    while (!WindowShouldClose())
    {
        // Klick-Erkennung
        if (!gameWon && IsMouseButtonPressed(MOUSE_LEFT_BUTTON))
        {
            Vector2 mouse = GetMousePosition();

            for (auto &c : cubes)
            {
                if (!c.IsFlipped() && !c.IsMatched())
                {
                    Vector2 screenPos = GetWorldToScreen({c.GetPosition().x, c.GetPosition().y, c.GetPosition().z}, camera);

                    if (fabs(mouse.x - screenPos.x) < 40 && fabs(mouse.y - screenPos.y) < 40)
                        c.FlipForward();
                }
            }
        }

        // Animation aller Würfel
        for (auto &c : cubes)
        {
            c.Update(flipSpeed);

            // Sobald ein Würfel vollständig umgedreht ist → merken
            if (c.IsFlipped() && !c.IsMatched())
            {
                if (!first) first = &c;
                else if (!second && &c != first) second = &c;
            }
        }

        // Matching-Logik
        if (first && second)
        {
            Color col1 = first->GetColor();
            Color col2 = second->GetColor();

            if (col1.r == col2.r && col1.g == col2.g && col1.b == col2.b)
            {
                first->SetMatched(true);
                second->SetMatched(true);
            }
            else
            {
                first->FlipBackward();
                second->FlipBackward();
            }

            first = second = nullptr;
        }

        // Gewinnprüfung
        if (!gameWon)
            gameWon = std::all_of(cubes.begin(), cubes.end(), [](const gamecube &c){ return c.IsMatched(); });

        // -----------------------------------------------------------
        // Zeichnen
        // -----------------------------------------------------------
        BeginDrawing();
        ClearBackground(RAYWHITE);
        BeginMode3D(camera);

        for (auto &c : cubes)
            c.Draw();

        EndMode3D();

        if (gameWon)
            DrawText("Congrats! You found all pairs!", 150, 260, 30, DARKBLUE);
        else
            DrawText("Flip 2 cubes - find matching pairs!", 10, 10, 20, DARKGRAY);

        EndDrawing();
    }

    CloseWindow();
    return 0;
}